#include "drivers.h"
#include "gdt.h"
#include "idt.h"
#include "kprintf.h"
#include "memory.h"
#include "power.h"
#include "shell.h"
#include "terminal.h"

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

/* Check if the compiler thinks you are targeting the wrong operating system. */
#if defined(__linux__)
#error                                                                         \
    "You are not using a cross-compiler, you will most certainly run into trouble"
#endif

/* This tutorial will only work for the 32-bit ix86 targets. */
#if !defined(__i386__)
#error "This tutorial needs to be compiled with a ix86-elf compiler"
#endif

void kernel_main(void)
{
	terminal_initialize();
	init_gdt();
	init_idt();
	init_memory();
	load_drivers();
	shell_init();
}
